import java.util.ArrayList;

/**
 * Klasse zur Verwaltung von Muenzen
 * 
 * @R.Ortner
 * @17.10.2019
 */
public class Kassa
{
    private static int[] muenzen = {1,2,5,10,20,50,100,200};
    private int[] kassastand;

    public Kassa()
    {
        this.kassastand = new int[8];
    }

    /**
     * zahlt Wert in Muenzen aus
     */
    public ArrayList<Muenze> auszahlen(int wert)
    {
        ArrayList<Muenze> dieM = new ArrayList<>();

        // lege Kopie von kassastand an;
        int[] kassastandkopie = kassastand.clone();
        
        for(int i=muenzen.length-1; i>=0; i--)
        {
            while(wert>=muenzen[i]&&kassastandkopie[i]>0)
            {
                wert = wert - muenzen[i];
                kassastandkopie[i]--;
                dieM.add(new Muenze(muenzen[i]));
            }
        }
        
        if(wert==0){
           kassastand = kassastandkopie; 
           return dieM;
        }
        
        return new ArrayList<Muenze>();
           
    }

    /**
     * zahlt Muenze ein
     */
    public void einzahlen(Muenze m)
    {
        for(int i=0; i<muenzen.length;i++)
        {
            if(m.getWert()==muenzen[i]){
                this.kassastand[i]++;
                break;
            }
        }
    }
}
